% This script generates a pathological example with (3^p+1)/2 linear segments
% The homotopy implementation is not designed to be fast, but to be numerically stable.
format compact;
p=11;       % should be small since the path has exponential size 
            %(it gives the correct path for p <= 11, but fails because of numerical precision for p>=12)

y=1;
X=1;
eps=0.99;
epsprecision=1e-16;
lambdamin=0;
for ii = 1:p;
   [path constantsegment lambdapath]=approx_lasso(X'*y,X'*X,y,X,0,lambdamin,epsprecision,false);
   if (ii ~= p)
      lambda1=lambdapath(end-1);
      w=path(:,end-1);
      yn=1;
      alpha=eps*lambda1/(2*y'*(y-X*w)+yn^2);
      beta=2*alpha;
      X=[X, beta*y;
      zeros(1,size(X,2)), alpha*yn];
      y=[y; yn];
   end
end
fprintf('Problem size: n=%d, p=%d\n',size(path,1),size(path,1));
fprintf('Computed path has %d linear segmnts\n',size(path,2));
fprintf('Theoretical path has %d linear segments\n',(3^p+1)/2);
